(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["ReactKeyHandler"] = factory(require("react"));
	else
		root["ReactKeyHandler"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_3__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = __webpack_require__(1);

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	exports.keyHandler = keyHandler;
	exports.keyToggleHandler = keyToggleHandler;

	var _constants = __webpack_require__(2);

	var _loop = function _loop(_key2) {
	  if (_key2 === "default") return 'continue';
	  Object.defineProperty(exports, _key2, {
	    enumerable: true,
	    get: function get() {
	      return _constants[_key2];
	    }
	  });
	};

	for (var _key2 in _constants) {
	  var _ret = _loop(_key2);

	  if (_ret === 'continue') continue;
	}

	var _react = __webpack_require__(3);

	var _react2 = _interopRequireDefault(_react);

	var _keycodes = __webpack_require__(4);

	var _keycodes2 = _interopRequireDefault(_keycodes);

	var _exenv = __webpack_require__(5);

	var _utils = __webpack_require__(6);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	/**
	 * KeyHandler component.
	 */

	/**
	 * Types.
	 */

	var KeyHandler = function (_React$Component) {
	  _inherits(KeyHandler, _React$Component);

	  _createClass(KeyHandler, [{
	    key: 'shouldComponentUpdate',
	    value: function shouldComponentUpdate() {
	      return false;
	    }
	  }]);

	  function KeyHandler(props) {
	    _classCallCheck(this, KeyHandler);

	    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(KeyHandler).call(this, props));

	    _this.handleKey = _this.handleKey.bind(_this);
	    return _this;
	  }

	  _createClass(KeyHandler, [{
	    key: 'componentDidMount',
	    value: function componentDidMount() {
	      if (!_exenv.canUseDOM) return;

	      window.document.addEventListener(this.props.keyEventName, this.handleKey);
	    }
	  }, {
	    key: 'componentWillUnmount',
	    value: function componentWillUnmount() {
	      if (!_exenv.canUseDOM) return;

	      window.document.removeEventListener(this.props.keyEventName, this.handleKey);
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      return null;
	    }
	  }, {
	    key: 'handleKey',
	    value: function handleKey(event) {
	      var keyCode = this.props.keyCode || (0, _keycodes2.default)(this.props.keyName);

	      if (event.keyCode !== keyCode) {
	        return;
	      }

	      var target = event.target;


	      if (target instanceof window.HTMLElement) {
	        if ((0, _utils.isInput)(target)) {
	          return;
	        }
	      }

	      this.props.onKeyHandle(event);
	    }
	  }]);

	  return KeyHandler;
	}(_react2.default.Component);

	/**
	 * Types.
	 */

	KeyHandler.defaultProps = {
	  keyEventName: _constants.KEYUP
	};
	exports.default = KeyHandler;


	/**
	 * KeyHandler decorators.
	 */

	function keyHandler(_ref) {
	  var keyCode = _ref.keyCode;
	  var keyName = _ref.keyName;
	  var keyEventName = _ref.keyEventName;

	  return function (component) {
	    return function (_React$Component2) {
	      _inherits(KeyHandleDecorator, _React$Component2);

	      function KeyHandleDecorator(props) {
	        _classCallCheck(this, KeyHandleDecorator);

	        var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(KeyHandleDecorator).call(this, props));

	        _this2.state = { keyCode: null, keyName: null };


	        _this2.handleKey = _this2.handleKey.bind(_this2);
	        return _this2;
	      }

	      _createClass(KeyHandleDecorator, [{
	        key: 'render',
	        value: function render() {
	          return _react2.default.createElement(
	            'div',
	            null,
	            _react2.default.createElement(KeyHandler, { keyCode: keyCode, keyEventName: keyEventName, keyName: keyName, onKeyHandle: this.handleKey }),
	            this.renderDecoratedComponent()
	          );
	        }
	      }, {
	        key: 'renderDecoratedComponent',
	        value: function renderDecoratedComponent() {
	          var _state = this.state;
	          var keyCode = _state.keyCode;
	          var keyName = _state.keyName;


	          return _react2.default.createElement(component, _extends({}, this.props, { keyCode: keyCode, keyName: keyName }));
	        }
	      }, {
	        key: 'handleKey',
	        value: function handleKey(event) {
	          this.setState({ keyCode: event.keyCode, keyName: (0, _keycodes2.default)(event.keyCode) });
	        }
	      }]);

	      return KeyHandleDecorator;
	    }(_react2.default.Component);
	  };
	}

	function keyToggleHandler(_ref2) {
	  var keyCode = _ref2.keyCode;
	  var keyName = _ref2.keyName;
	  var keyEventName = _ref2.keyEventName;

	  return function (component) {
	    return function (_React$Component3) {
	      _inherits(KeyHandleDecorator, _React$Component3);

	      function KeyHandleDecorator(props) {
	        _classCallCheck(this, KeyHandleDecorator);

	        var _this3 = _possibleConstructorReturn(this, Object.getPrototypeOf(KeyHandleDecorator).call(this, props));

	        _this3.state = { keyCode: null, keyName: null };


	        _this3.handleToggleKey = _this3.handleToggleKey.bind(_this3);
	        return _this3;
	      }

	      _createClass(KeyHandleDecorator, [{
	        key: 'render',
	        value: function render() {
	          return _react2.default.createElement(
	            'div',
	            null,
	            _react2.default.createElement(KeyHandler, { keyCode: keyCode, keyEventName: keyEventName, keyName: keyName, onKeyHandle: this.handleToggleKey }),
	            this.renderDecoratedComponent()
	          );
	        }
	      }, {
	        key: 'renderDecoratedComponent',
	        value: function renderDecoratedComponent() {
	          var _state2 = this.state;
	          var keyCode = _state2.keyCode;
	          var keyName = _state2.keyName;


	          return _react2.default.createElement(component, _extends({}, this.props, { keyCode: keyCode, keyName: keyName }));
	        }
	      }, {
	        key: 'handleToggleKey',
	        value: function handleToggleKey(event) {
	          if (this.state.keyCode === event.keyCode) {
	            return this.setState({ keyCode: null, keyName: null });
	          }

	          this.setState({ keyCode: event.keyCode, keyName: (0, _keycodes2.default)(event.keyCode) });
	        }
	      }]);

	      return KeyHandleDecorator;
	    }(_react2.default.Component);
	  };
	}

/***/ },
/* 2 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	/**
	 * Key event names.
	 */

	var KEYDOWN = exports.KEYDOWN = 'keydown';
	var KEYPRESS = exports.KEYPRESS = 'keypress';
	var KEYUP = exports.KEYUP = 'keyup';

/***/ },
/* 3 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ },
/* 4 */
/***/ function(module, exports) {

	'use strict';

	var keys = {
	  ctrl: 17,
	  control: 17,
	  alt: 18,
	  option: 18,
	  shift: 16,
	  windows: 91,
	  command: 91,
	  esc: 27,
	  escape: 27,
	  '`': 192,
	  '-': 189,
	  '=': 187,
	  backspace: 8,
	  tab: 9,
	  '\\': 220,
	  '[': 219,
	  ']': 221,
	  ';': 186,
	  '\'': 222,
	  enter: 13,
	  'return': 13,
	  ',': 188,
	  '.': 190,
	  '/': 191,
	  space: 32,
	  pause: 19,
	  'break': 19,
	  insert: 45,
	  'delete': 46,
	  home: 36,
	  end: 35,
	  pageup: 33,
	  pagedown: 34,
	  left: 37,
	  up: 38,
	  right: 39,
	  down: 40,
	  capslock: 20,
	  numlock: 144,
	  scrolllock: 145
	};

	for (var f = 1; f < 20; f++) {
	  keys['f' + f] = 111 + f;
	}

	module.exports = function (input) {
	  if (typeof input === 'string') return code(input);
	  if (typeof input === 'number') return key(input);
	};

	function code(input) {
	  return keys[input.toLowerCase()] || input.toUpperCase().charCodeAt(0);
	}

	function key(input) {
	  for (var k in keys) {
	    if (keys.hasOwnProperty(k)) {
	      if (keys[k] === input) return k;
	    }
	  }

	  return String.fromCharCode(input).toLowerCase();
	}


/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/*!
	  Copyright (c) 2015 Jed Watson.
	  Based on code that is Copyright 2013-2015, Facebook, Inc.
	  All rights reserved.
	*/

	(function () {
		'use strict';

		var canUseDOM = !!(
			typeof window !== 'undefined' &&
			window.document &&
			window.document.createElement
		);

		var ExecutionEnvironment = {

			canUseDOM: canUseDOM,

			canUseWorkers: typeof Worker !== 'undefined',

			canUseEventListeners:
				canUseDOM && !!(window.addEventListener || window.attachEvent),

			canUseViewport: canUseDOM && !!window.screen

		};

		if (true) {
			!(__WEBPACK_AMD_DEFINE_RESULT__ = function () {
				return ExecutionEnvironment;
			}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else if (typeof module !== 'undefined' && module.exports) {
			module.exports = ExecutionEnvironment;
		} else {
			window.ExecutionEnvironment = ExecutionEnvironment;
		}

	}());


/***/ },
/* 6 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.isInput = isInput;


	/**
	 * Check if `given` element is an input or textarea form element.
	 */

	function isInput(element) {
	  if (!element) {
	    return false;
	  }

	  var tagName = element.tagName;


	  return tagName === 'INPUT' || tagName === 'TEXTAREA';
	}

/***/ }
/******/ ])
});
;